package edu.uci.eecs.specCompiler.specExtraction;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.io.LineNumberReader;
import java.util.ArrayList;

import edu.uci.eecs.specCompiler.grammerParser.ParseException;
import edu.uci.eecs.specCompiler.grammerParser.SpecParser;
import edu.uci.eecs.specCompiler.grammerParser.TokenMgrError;

/**
 * <p>
 * This class represents the specification extractor of the specification. The
 * main function of this class is to read C/C++11 source files and extract the
 * corresponding specification out, and remember its location, including the
 * file name and the line number, to help the code generation process.
 * </p>
 * 
 * @author peizhaoo
 * 
 */
public class SpecExtractor {
	private ArrayList<Construct> _constructs;
	private int _beginLineNum, _endLineNum;
	private String _beginLine;

	public SpecExtractor() {
		_constructs = new ArrayList<Construct>();
	}
	
	ArrayList<Construct> getConstructs() {
		return this._constructs;
	}

	/**
	 * <p>
	 * Given a list of files, it scans each file and add found SpecConstrcut to
	 * the _constructs list.
	 * </p>
	 * 
	 * @param files
	 * @throws SpecNotMatchException
	 */
	public void extract(File[] files) {
		for (int i = 0; i < files.length; i++)
			extract(files[i]);
	}

	public void extract(File file) {
		StringBuilder specText = new StringBuilder();
		
	}

	public static String trimSpace(String line) {
		int i, j;
		char ch;
		for (i = 0; i < line.length(); i++) {
			ch = line.charAt(i);
			if (ch != ' ' && ch != '\t')
				break;
		}
		for (j = line.length() - 1; j >= 0; j--) {
			ch = line.charAt(j);
			if (ch != ' ' && ch != '\t')
				break;
		}
		if (i > j)
			return "";
		else
			return line.substring(i, j + 1);
	}
}
